﻿using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Input;

namespace TestProject
{
    /// <summary>
    /// 메시지 컨트롤
    /// </summary>
    public partial class MessageControl : UserControl
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 커서
        /// </summary>
        private Cursor cursor;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MessageControl()

        /// <summary>
        /// 생성자
        /// </summary>
        public MessageControl()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Thumb 드래그 시작시 처리하기 - thumb_DragStarted(sender, e)

        /// <summary>
        /// Thumb 드래그 시작시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void thumb_DragStarted(object sender, DragStartedEventArgs e)
        {
            this.cursor = Cursor;

            Cursor = Cursors.SizeNWSE;
        }

        #endregion
        #region Thumb 드래그 델타 처리하기 - thumb_DragDelta(sender, e)

        /// <summary>
        /// Thumb 드래그 델타 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void thumb_DragDelta(object sender, DragDeltaEventArgs e)
        {
            double adjustX = this.sizableContent.ActualWidth  + e.HorizontalChange;
            double adjustY = this.sizableContent.ActualHeight + e.VerticalChange;

            adjustX = adjustX > this.sizableContent.MinWidth  ? adjustX : this.sizableContent.MinWidth;
            adjustY = adjustY > this.sizableContent.MinHeight ? adjustY : this.sizableContent.MinHeight;

            this.sizableContent.Width  = adjustX;
            this.sizableContent.Height = adjustY;
        }

        #endregion
        #region Thumb 드래그 완료시 처리하기 - thumb_DragCompleted(sender, e)

        /// <summary>
        /// Thumb 드래그 완료시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void thumb_DragCompleted(object sender, DragCompletedEventArgs e)
        {
            Cursor = this.cursor;
        }

        #endregion
    }
}